package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.excel.ExcelField;
import com.qmth.distributed.print.business.bean.result.ScoreResult;
import com.qmth.distributed.print.business.entity.TCUsualScore;
import com.qmth.teachcloud.mark.entity.MarkPaper;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 平常作业成绩表 服务类
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TCUsualScoreService extends IService<TCUsualScore> {

    /**
     * 成绩管理列表
     *
     * @param iPage
     * @param examId
     * @param courseCode
     * @return
     */
    public IPage<ScoreResult> scoreList(IPage<Map> iPage, Long examId, String courseCode);

    /**
     * 动态生成excel
     *
     * @param describe
     * @param sheetName
     * @param fileName
     * @param excelFieldList
     * @throws IOException
     */
    void downLoadExaminationTemplate(String describe, String sheetName, String fileName, List<ExcelField> excelFieldList) throws IOException;

    /**
     * 导入excel校验
     *
     * @param file
     * @param examId
     * @param paperNumber
     * @return
     */
    public MarkPaper importExcelVaild(MultipartFile file, Long examId, String paperNumber) throws IOException;
}
